/*
    Tucnak - VHF contest log
    Copyright (C) 2002-2004  Ladislav Vaiz <ok1zia@nagano.cz>

    This program is free software; you can redistribute it and/or                                                        
    modify it under the terms of the GNU General Public License                                                          
    version 2 as published by the Free Software Foundation.

*/
#include "header.h"

#ifdef HAVE_SDLDYN


SDL_Surface * (*pSDL_CreateRGBSurface)(Uint32 flags, int width, int height, int depth, Uint32 Rmask, Uint32 Gmask, Uint32 Bmask, Uint32 Amask);
SDL_Thread * (*pSDL_CreateThread)(int (*fn)(void *), void *data);
void (*pSDL_Delay)(Uint32 ms);
int (*pSDL_EnableKeyRepeat)(int delay, int interval);
int (*pSDL_EnableUNICODE)(int enable);
int (*pSDL_FillRect)(SDL_Surface *dst, SDL_Rect *dstrect, Uint32 color);
void (*pSDL_FreeSurface)(SDL_Surface *surface);
SDLMod (*pSDL_GetModState)();
void (*pSDL_GetRGB)(Uint32 pixel, SDL_PixelFormat *fmt,	Uint8 *r, Uint8 *g, Uint8 *b);
const SDL_VideoInfo * (*pSDL_GetVideoInfo)();
int (*pSDL_Init)(Uint32 flags);
SDL_Rect ** (*pSDL_ListModes)(SDL_PixelFormat *format, Uint32 flags);
Uint32 (*pSDL_MapRGB)(SDL_PixelFormat *format, Uint8 r, Uint8 g, Uint8 b);
int (*pSDL_PeepEvents)(SDL_Event *events, int numevents, SDL_eventaction action, Uint32 mask);
void (*pSDL_PumpEvents)();
void (*pSDL_Quit)();
SDL_RWops * (*pSDL_RWFromConstMem)(const void *mem, int size);
SDL_RWops * (*pSDL_RWFromFile)(const char *file, const char *mode);
SDL_bool (*pSDL_SetClipRect)(SDL_Surface *surface, const SDL_Rect *rect);
int (*pSDL_SetColorKey)(SDL_Surface *surface, Uint32 flag, Uint32 key);
int (*pSDL_SetColors)(SDL_Surface *surface, SDL_Color *colors, int firstcolor, int ncolors);
SDL_Surface * (*pSDL_SetVideoMode)(int width, int height, int bpp, Uint32 flags);
void (*pSDL_UpdateRect)(SDL_Surface *screen, Sint32 x, Sint32 y, Uint32 w, Uint32 h);
int (*pSDL_UpperBlit)(SDL_Surface *src, SDL_Rect *srcrect, SDL_Surface *dst, SDL_Rect *dstrect);
char * (*pSDL_VideoDriverName)(char *namebuf, int maxlen);
void (*pSDL_WaitThread)(SDL_Thread *thread, int *status);
void (*pSDL_WM_SetCaption)(const char *title, const char *icon);
void (*pSDL_WM_SetIcon)(SDL_Surface *icon, Uint8 *mask);

#ifdef __CYGWIN__
#define LOAD_SDL(sym) \
    p##sym = GetProcAddress(sdl->sdlhandle, #sym); \
    if (!p##sym) { internal("Can't load symbol "#sym"");dlclose(sdl->sdlhandle); return 1; }
#else
#define LOAD_SDL(sym) \
    p##sym = dlsym(sdl->sdlhandle, #sym); \
    if (!p##sym) { internal("Can't load symbol "#sym"");dlclose(sdl->sdlhandle); return 1; }
#endif

int load_sdldyn(struct sdl *sdl){
    dbg("load_sdldyn()\n");
#ifdef __CYGWIN__
    sdl->sdlhandle = LoadLibrary("SDL.dll");
#else
    sdl->sdlhandle = dlopen("/usr/lib/libSDL-1.2.so.0", RTLD_NOW);
#endif
    if (!sdl->sdlhandle) internal("Can't dlopen libSDL");
    LOAD_SDL(SDL_CreateRGBSurface);
    LOAD_SDL(SDL_CreateThread);
    LOAD_SDL(SDL_Delay);
    LOAD_SDL(SDL_EnableKeyRepeat);
    LOAD_SDL(SDL_EnableUNICODE);
    LOAD_SDL(SDL_FillRect);
    LOAD_SDL(SDL_FreeSurface);
    LOAD_SDL(SDL_GetModState);
    LOAD_SDL(SDL_GetRGB);
    LOAD_SDL(SDL_GetVideoInfo);
    LOAD_SDL(SDL_Init);
    LOAD_SDL(SDL_ListModes);
    LOAD_SDL(SDL_MapRGB);
    LOAD_SDL(SDL_PeepEvents);
    LOAD_SDL(SDL_PumpEvents);
    LOAD_SDL(SDL_Quit);
    LOAD_SDL(SDL_RWFromConstMem);
    LOAD_SDL(SDL_RWFromFile);
    LOAD_SDL(SDL_SetClipRect);
    LOAD_SDL(SDL_SetColorKey);
    LOAD_SDL(SDL_SetColors);
    LOAD_SDL(SDL_SetVideoMode);
    LOAD_SDL(SDL_UpdateRect);
    LOAD_SDL(SDL_UpperBlit);
    LOAD_SDL(SDL_VideoDriverName);
    LOAD_SDL(SDL_WaitThread);
    LOAD_SDL(SDL_WM_SetCaption);
    LOAD_SDL(SDL_WM_SetIcon);
    return 0;
};

void free_sdldyn(struct sdl *sdl){
    if (sdl->sdlhandle) dlclose(sdl->sdlhandle);
}

#ifdef __CYGWIN__
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine,int nCmdShow){
	printf("WinMain(%p, %p, '%s', %d);\n", hInstance, hPrevInstance, lpCmdLine, nCmdShow);
}

#endif

#endif
